#
# $Id: asterisk.spec,v 1.8 2005/03/28 14:11:54 build Exp $
#

%define cvsdate	20050328

Summary:	An Open Source PBX and telephony toolkit.
Name:		asterisk
Version:	0.0.cvs+%{cvsdate}
Release:	1.5.12
Group:		System Environment/Daemons
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:	asterisk.init-gd-2
Patch00:	asterisk-0.0.cvs+20050125-shut-up-manager-gd-1.diff
Patch01:	asterisk+cvs20040226-awkfix-gd-1.diff
Patch02:	asterisk+cvs20041228-define-POPT_ARGFLAG_SHOW_DEFAULT-gd-1.diff
URL:		ftp://ftp.asterisk.org/pub/telephony/
BuildRoot:	%{_tmppath}/%{name}-%{release}-root
Requires:	/usr/sbin/useradd

%description
Asterisk is an Open Source PBX and telephony toolkit.  It is, in a
sense, middleware between Internet and telephony channels on the bottom,
and Internet and telephony applications at the top.  For more information
on the project itself, please visit the Asterisk home page at
http://www.asterisk.org.

%files
  %defattr(-,root,root)

  %attr(0510,root,asterisk)	%{_sbindir}/*
  %attr(0500,root,root)		%{_sysconfdir}/init.d/asterisk
  %attr(0700,asterisk,root)	%dir %{_localstatedir}/run/asterisk

  # configuration files
  %attr(0710,root,asterisk)	%dir %{_sysconfdir}/asterisk
  %attr(0640,root,asterisk)	%config(noreplace) %{_sysconfdir}/asterisk/*.adsi
  %attr(0640,root,asterisk)	%config(noreplace) %{_sysconfdir}/asterisk/*.conf

  # modules
  %attr(0710,root,asterisk)	%dir %{_libdir}/asterisk
  %attr(0550,root,asterisk)	%{_libdir}/asterisk/addmailbox
  %attr(0750,root,asterisk)	%dir %{_libdir}/asterisk/modules
  %attr(0550,root,asterisk)	%{_libdir}/asterisk/modules/*.so

  # agi-bin
  %attr(0710,root,asterisk)	%dir %{_localstatedir}/lib/asterisk
  %attr(0710,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/agi-bin
  %attr(0550,root,asterisk)	%{_localstatedir}/lib/asterisk/agi-bin/*

  # IAX firmware
  %attr(0710,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/firmware
  %attr(0770,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/firmware/iax
  %attr(0660,root,asterisk)	%{_localstatedir}/lib/asterisk/firmware/iax/*

  # images
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/images
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/images/*

  # keys
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/keys
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/keys/*

  # mohmp3
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/mohmp3
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/mohmp3/*

  # sounds
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/sounds
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/sounds/digits
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/sounds/letters
  %attr(0750,root,asterisk)	%dir %{_localstatedir}/lib/asterisk/sounds/phonetic
  %attr(0750,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/vm
  %attr(0750,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/voicemail
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/*.gsm
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/digits/*.gsm
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/letters/*.gsm
  %attr(0640,root,asterisk)	%{_localstatedir}/lib/asterisk/sounds/phonetic/*.gsm

  # voicemail
  %attr(0750,asterisk,root)	%dir %{_localstatedir}/spool/asterisk
  %attr(0750,asterisk,root)	%dir %{_localstatedir}/spool/asterisk/voicemail
  %attr(0750,asterisk,root)	%{_localstatedir}/spool/asterisk/vm

%package devel
Summary:	Header files for Asterisk development
Group:		Development/Libraries
Requires:	asterisk = %{version}

%description devel
This package contains the asterisk header files used for asterisk
application development.

%files devel
  %defattr(-,root,root)

  %attr(0555,root,root)		%dir %{_includedir}/asterisk
  %attr(0440,root,root)		%{_includedir}/asterisk/*.h

%prep
%setup -q
%patch00 -p1
%patch01 -p1
%patch02 -p1

%build
  make

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/init.d
  make DESTDIR=$RPM_BUILD_ROOT ASTVARRUNDIR=%{_localstatedir}/run/asterisk install samples

  #
  # Install additional sources.
  #
  install %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/asterisk
  install ./contrib/scripts/addmailbox $RPM_BUILD_ROOT/%{_libdir}/asterisk

  #
  # Fixes
  #
  pushd $RPM_BUILD_ROOT
    ln -s voicemail/default           ./var/spool/asterisk/vm
    ln -s ../../../spool/asterisk/vm/ ./var/lib/asterisk/sounds/vm

    rm -fr ./var/spool/asterisk/voicemail/default/1234
  popd

%pre
  if [ "$1" = 1 ] ; then
	/usr/sbin/useradd -d /var/run/asterisk -s /bin/bash -c "Asterisk PBX daemon" -r asterisk > /dev/null 2>&1 || :
  fi

  mkdir -p /var/log/asterisk
  chown -R asterisk.asterisk /var/log/asterisk
  chmod 710 /var/log/asterisk

%post
  if [ -f /var/lock/subsys/asterisk ]; then
        /etc/init.d/asterisk restart > /dev/null 2>&1 || :
  fi

%preun
  if [ $1 = 0 ]; then
        /etc/init.d/asterisk stop > /dev/null 2>&1 || :
        /sbin/chkconfig --del asterisk
	/usr/sbin/userdel -r asterisk
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Mar 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20050328, Release 1.5.12
  - Updated to latest upstream CVS snapshot.
  - Remove plc-jitterbuffer patch, it's now in CVS.

* Tue Jan 25 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20050125, Release 1.5.11
  - Updated to latest upstream CVS snapshot.
  - Updated the "shut-up-manager" patch.
  - Bring in an experimental new PLC jitterbuffer (bug #0002532).
  - Fix 'vm' symlinks in /var/spool/asterisk and /var/lib/asterisk/sounds.
  - Remove default 'vm' mailbox.
  - Package the 'addmailbox' script in /usr/lib/asterisk.

* Wed Dec 29 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20041228, Release 1.5.10
  - Put asterisk's shell back to /bin/false.
  - Get non-root functionality working for good.
  - Pause for two seconds when restarting in the initscript.
  - Further permission fixes for running non-root.

* Fri Dec 17 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20041217, Release 1.5.9
  - Update to latest CVS snapshot.
  - Give the asterisk user a real shell instead of /bin/false.
  - POPT_ARGFLAG_SHOW_DEFAULT does not exist in our version of rpm/popt,
    so define it in utils/smsq.c.

* Wed Nov 10 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20041110, Release 1.5.8
  - Update initscript to make stopping more pretty.
  - Don't patch in initscript anymore, make it a SOURCE.

* Mon Nov 08 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20041108, Release 1.5.7
  - Update to latest upstream CVS.
  - Remove the asterisk user upon package removal.
  - Force ASTVARRUNDIR to /var/run/asterisk so we can run non-root.
  - Update the initscript to run non-root.
  - Update various permissions so they work when asterisk is non-root, and
    tighen up other various permissions..

* Wed Aug 04 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040804, Release 1.5.6
  - Update to latest upstream CVS.
  - Update source naming scheme and remove 'libpri' stuff.
  - Shut up manager.c...

* Wed Jul 28 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040723, Release 1.5.5
  - Package the 'letters' directory.

* Fri Jul 23 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040723, Release 1.5.4
  - Update to latest upstream CVS.

* Tue May 11 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040511, Release 1.5.3
  - Update to latest upstream CVS.
  - Don't package IAX firmware anymore.

* Fri Feb 26 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040226, Release 1.5.2
  - Bring in engarde/ subdir with initscript, and install it.
  - Mark configuration files %config(noreplace).

* Fri Feb 26 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 0.0.cvs+20040226, Release 1.5.1
  - Initial build for EnGarde.
